<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XPatternMember StructType
 * @subpackage Structs
 */
class XPatternMember extends AbstractStructBase
{
    /**
     * The selectionOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $selectionOrder;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The dialParameters
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\DialParameters
     */
    public $dialParameters;
    /**
     * Constructor method for XPatternMember
     * @uses XPatternMember::setSelectionOrder()
     * @uses XPatternMember::setDescription()
     * @uses XPatternMember::setDialParameters()
     * @param string $selectionOrder
     * @param string $description
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\DialParameters $dialParameters
     */
    public function __construct($selectionOrder = null, $description = null, \\Losc\CucmBundle\Model\Webservice\StructType\DialParameters $dialParameters = null)
    {
        $this
            ->setSelectionOrder($selectionOrder)
            ->setDescription($description)
            ->setDialParameters($dialParameters);
    }
    /**
     * Get selectionOrder value
     * @return string
     */
    public function getSelectionOrder()
    {
        return $this->selectionOrder;
    }
    /**
     * Set selectionOrder value
     * @param string $selectionOrder
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XPatternMember
     */
    public function setSelectionOrder($selectionOrder = null)
    {
        $this->selectionOrder = $selectionOrder;
        return $this;
    }
    /**
     * Get description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : null;
    }
    /**
     * Set description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XPatternMember
     */
    public function setDescription($description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->description);
        } else {
            $this->description = $description;
        }
        return $this;
    }
    /**
     * Get dialParameters value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\DialParameters|null
     */
    public function getDialParameters()
    {
        return $this->dialParameters;
    }
    /**
     * Set dialParameters value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\DialParameters $dialParameters
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XPatternMember
     */
    public function setDialParameters(\\Losc\CucmBundle\Model\Webservice\StructType\DialParameters $dialParameters = null)
    {
        $this->dialParameters = $dialParameters;
        return $this;
    }
}
